/******************************************************************************
 *	csese.c:	t͗p^_CAO֐W[
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sxmemory.h>		/* }𗘗pƂɕKv	*/
#include <console.h>		/* R\[n}l[W𗘗pƂɕKv */
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Ot}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <text.h>		/* eLXg}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "cash.h"		/* ̃vOŗL̃wb_t@C	*/

short funcKeyTbl[] = {			/* t@NVL[ATCe[u */
	K_HOME,  0,			/* [HOME]	*/
	K_DEL,   0x07,			/* [DEL]	*/
	K_RUP,   0x03,			/* [ROLL UP]	*/
	K_RDOWN, 0x12,			/* [ROLL DOWN]	*/
	K_UNDO,  0,			/* [UNDO]	*/
	K_LEFT,  0x13,			/* []		*/
	K_UP,    0x05,			/* []		*/
	K_RIGHT, 0x04,			/* []		*/
	K_DOWN,  0x18,			/* []		*/
	K_CLR,   0,			/* [CLR]	*/
	K_HELP,  0,			/* [HELP]	*/
	K_INS,   0,			/* [INS]	*/
	0, 0				/* e[uI[	*/
};

/******************************************************************************
 *	openEseDlg():	^_CAÕI[v
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		Window *winPtr	EBhE|C^
 *		char *title	_CAO^Cgւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 *	:
 *	^_CAÕ[NB
 *	^_CAO̕\showEseDlg()ōsB
 */
BOOLEAN openEseDlg(EseDlg *pese, Window *winPtr, char *title)
{
	/* ^_CAO̊eW */
	static Rect rcFrame = {		/* Og				*/
		ESE_X + 0, ESE_Y + 0, ESE_X + 221, ESE_Y + 94
	};
	static Rect rcText = {		/* eLXg͗(1)		*/
		ESE_X + 14, ESE_Y + 30, ESE_X + 42, ESE_Y + 48
	};
	static Rect rcText2 = {		/* eLXg͗(2)		*/
		ESE_X + 64, ESE_Y + 30, ESE_X + 92, ESE_Y + 48
	};
	static Rect rcPart = {		/* {^̃p[eBV	*/
		ESE_X + 118, ESE_Y + 47, ESE_X + 201, ESE_Y + 77
	};
	/* _CAO^Cg̕\ʒu */
	static Point ttlPos = { ESE_X + 15, ESE_Y + 15 };
	static Point esettlPos21 = { ESE_X + 45, ESE_Y + 33 }; /* ''	*/
	static Point esettlPos22 = { ESE_X + 95, ESE_Y + 33 }; /* ''	*/

	pese->windowPtr = winPtr;
	pese->rcFrame = rcFrame;	/* OgN^O̓o^	*/
	pese->rcText[0] = rcText;	/* eLXgp̃N^O	*/
	pese->rcText[1] = rcText2;
	pese->rcDest = rcText;
	pese->rcPart = rcPart;		/* {^̃p[eBV	*/
	pese->ttlPos = ttlPos;		/* ^Cg\W		*/
	pese->ttlPos2[0] = esettlPos21;
	pese->ttlPos2[1] = esettlPos22;
	pese->tmode = 0;
	pese->visible = 0;
	*pese->tBuff[0] = 0;		/* ̏		*/
	*pese->tBuff[1] = 0;

	pese->title = MMChHdlNew(256);	/* ^Cgpnhmۂ */
	if (pese->title == NULL)
		return FALSE;

	strcpy(*pese->title, title);	/* ^Cgݒ肷		*/
	if (!createEseText(pese))	/* eLXgGfBbg쐬	*/
		return FALSE;

	if (!createEseControl(pese))	/* Rg[쐬	*/
		return FALSE;

	return TRUE;
}

/******************************************************************************
 *	closeEseDlg():	^_CAÕN[Y
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *	:
 *	^_CAOAmۂĂRg[nhȂǁAׂĔp
 *	܂B
 */
void closeEseDlg(EseDlg *pese)
{
	int lastFC, lastAP;

	if (pese->visible) {
		GMSetGraph(&pese->windowPtr->graph);
		/* ANZXy[WOƂPy[Wɂ */
		lastAP = GMAPage(G_PAGE0 | G_PAGE1);
		lastFC = GMForeColor(G_LGRAY);
		releaseClip(pese->windowPtr);
		GMFillRect(&pese->rcFrame);
		addUpdate(pese->windowPtr, &pese->rcFrame);
		GMAPage(lastAP);
		GMForeColor(lastFC);
	}
	if (pese->tEdit != NULL) {
		/* eLXgGfBbgnhp */
		TMDispose(pese->tEdit);
		pese->tEdit = NULL;
	}
	if (pese->execBtnHdl != NULL) {
		CMDispose(pese->execBtnHdl);
		pese->execBtnHdl = NULL;
	}
	if (pese->canBtnHdl != NULL) {
		CMDispose(pese->canBtnHdl);
		pese->canBtnHdl = NULL;
	}
	MMHdlDispose(pese->title);	/* nh		*/
	pese->title = NULL;
}

/******************************************************************************
 *	drawEseDlg():	^_CAO̕`
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 */
void drawEseDlg(EseDlg *pese)
{
	int lastAP, lastFC, lastBC, lastFK;
	int mode;
	Point pt;
	char str[16];

	if (!pese->visible)		/* \ĂȂH		*/
		return;

	GMSetGraph(&pese->windowPtr->graph);
	releaseClip(pese->windowPtr);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_LGRAY);
	lastFK = GMFontKind(G_ROM12);

	GMScrewRect(&pese->rcFrame);	/* lWtN^O\	*/
	GMShadowRect(&pese->rcPart);
	CMDrawOne(pese->execBtnHdl);	/* {^`悷		*/
	CMDrawOne(pese->canBtnHdl);
	MMHdlLock(pese->title);
	GMShadowStrZ(*pese->title, pese->ttlPos.x_y); /* {^`悷 */
	MMHdlUnlock(pese->title);
	/* ҏW[hɂ؂ւ */
	GMShadowStrZ("", pese->ttlPos2[0].x_y);
	GMShadowStrZ("", pese->ttlPos2[1].x_y);

	/* eLXg̈̕` */
	GMBackColor(G_WHITE);
	GMShadowRect(&pese->rcText[0]);
	GMShadowRect(&pese->rcText[1]);
	/* \ƁA\WI */
	mode = 1 - pese->tmode;
	sprintf(str, "%3d\0", pese->value[mode]);
	pt.x_y = pese->rcText[mode].l.l_t;
	pt.p.x += 3;
	pt.p.y += 3;
	GMMove(pt.x_y);
	GMDrawStrZ(str);
	/* eLXgGfBbg̕`悷 */
	TMUpDate(pese->tEdit, &pese->rcDest);

	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);
	setClip(pese->windowPtr, &pese->rcFrame);
}

/******************************************************************************
 *	showEseDlg():	^_CAO̕\
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 */
void showEseDlg(EseDlg *pese)
{
	int lastFC, lastAP;

	if (pese->visible)
		return;

	GMSetGraph(&pese->windowPtr->graph);
	releaseClip(pese->windowPtr);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_LGRAY);

	GMPenHide();
	CMShow(pese->execBtnHdl);
	CMShow(pese->canBtnHdl);
	GMPenShow();

	pese->visible = TRUE;
	moveEdit(pese, 0);		/* PԖڂ͍̓ڂҏW\ɂ */
	/* S͈͎w̏Ԃɂ */
	TMSetSelect(pese->tEdit, 0, (*pese->tEdit)->length, 0);
	TMShow(pese->tEdit);

	GMAPage(lastAP);
	GMForeColor(lastFC);

	/* Abvf[g[Wɓo^ */
	addUpdate(pese->windowPtr, &pese->rcFrame);
	setClip(pese->windowPtr, &pese->rcFrame);
}

/******************************************************************************
 *	hideEseDlg():	^_CAȌ
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 */
void hideEseDlg(EseDlg *pese)
{
	int lastFC, lastAP;

	if (!pese->visible)		/* \ĂȂH		*/
		return;

	GMSetGraph(&pese->windowPtr->graph);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_LGRAY);

	releaseClip(pese->windowPtr);
	pese->visible = FALSE;
	CMHide(pese->execBtnHdl);
	CMHide(pese->canBtnHdl);
	TMHide(pese->tEdit);
	GMFillRect(&pese->rcFrame);
	addUpdate(pese->windowPtr, &pese->rcFrame);

	GMAPage(lastAP);
	GMForeColor(lastFC);
}

/******************************************************************************
 *	createEseText():	^_CAOpeLXgGfBbg̍쐬
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN createEseText(EseDlg *pese)
{
	int errCode;

	/* eLXgpfBXeBl[VN^O쐬 */
	pese->rcDest.d.left += 3;
	pese->rcDest.d.top += 3;
	pese->rcDest.d.right -= 3;
	pese->rcDest.d.bottom -= 3;

	errCode = TMNew2(&pese->rcDest, &pese->rcDest, &pese->windowPtr->graph, &pese->tEdit);
	if (errCode < 0)
		/* eLXgGfBbg쐬łȂ */
		return FALSE;

	(*pese->tEdit)->lenMax = 3;	/* ͍ő啶ݒ肷	*/
	(*pese->tEdit)->lineHeight = T_LHEIGHT; /* sݒ肷	*/
	(*pese->tEdit)->editMode = 0;	/* ҏW[hʏ\ɂ	*/
	/* t@NVL[ATCe[uݒ肷 */
	(*pese->tEdit)->funcCode = funcKeyTbl;

	return TRUE;
}

/******************************************************************************
 *	createEseControl():	^_CAÕRg[̍쐬
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN createEseControl(EseDlg *pese)
{
	static Rect rcExecBtn = {	/* [s]{^			*/
		ESE_X + 124, ESE_Y + 53, ESE_X + 154, ESE_Y + 72
	};
	static Rect rcCanBtn = {	/* []{^			*/
		ESE_X + 166, ESE_Y + 53, ESE_X + 196, ESE_Y + 72
	};

	pese->execBtnHdl = CMOpen(pese->windowPtr, &rcExecBtn,
		(_LASCII)"\x04s", FALSE, 0, 0, 1, CI_CHRBTN << 4, 0);
	if (pese->execBtnHdl == NULL)
		return FALSE;

	pese->canBtnHdl = CMOpen(pese->windowPtr, &rcCanBtn,
		(_LASCII)"\x04", FALSE, 0, 0, 1, CI_CHRBTN << 4, 0);
	if (pese->canBtnHdl == NULL)
		return FALSE;

	return TRUE;
}

/******************************************************************************
 *	caretEseDlg():	^_CAÕJ[\
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		BOOLEAN sw	= TRUE:  \
 *				= FALSE: 
 */
void caretEseDlg(EseDlg *pese, BOOLEAN sw)
{
	int lastAP, lastFC, lastBC, lastFK;

	if (!pese->visible)		/* \ĂȂH		*/
		return;

	GMSetGraph(&pese->windowPtr->graph);
	releaseClip(pese->windowPtr);	/* NbsO	*/
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_WHITE);
	lastFK = GMFontKind(G_ROM12);

	TMCaret(pese->tEdit, sw);	/* J[\I^It	*/

	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);
	setClip(pese->windowPtr, &pese->rcFrame); /* NbsO߂	*/
}

/******************************************************************************
 *	eseDlgEvent():	Cxgɉ
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		TsEvent *ptsev	^XN}CxgR[hւ̃|C^
 *	߂l:	int num		= 1: [s]{^
 *				= 2: []{^
 */
int eseDlgEvent(EseDlg *pese, TsEvent *ptsev)
{
	int lastAP, lastFC, lastBC, lastFK;
	int keyCode;			/* L[R[h			*/
	int shortCut;			/* V[gJbgL[		*/
	int num = 0, len;
	int partCode;			/* Rg[̃p[gR[h	*/
	LPoint lpt;
	Control **ctrlHdl;		/* Rg[nh		*/

	if (!pese->visible)		/* \ĂȂH		*/
		return 0;

	GMSetGraph(&pese->windowPtr->graph);
	releaseClip(pese->windowPtr);
	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_WHITE);
	lastFK = GMFontKind(G_ROM12);

	switch (ptsev->ts.what) {
	case E_IDLE:			/* AChCxg		*/
		TMEventW(pese->tEdit, ptsev); /* J[\_ł	*/
		break;
	case E_KEYDOWN:			/* L[_ECxg		*/
		/* t@NVATCe[uɂL[R[hϊ */
		keyCode = TMKeyToAsk(pese->tEdit, ptsev);
		if (keyCode == -2) {	/* e[uɓo^ĂȂH	*/
			/* OPT.1L[ꂽH */
			if (ptsev->ev.how & KS_OPT1) {
				/* L[͂啶ɕϊ */
				shortCut = toupper((int) ptsev->ev.whom.key.ascii);
				switch (shortCut) {
				case 'Q':	/* I			*/
					num = 2; /* []{^	*/
					break;
				default:
					/* eLXg}̃V[gJbg
					   Ή */
					TMEventW(pese->tEdit, ptsev);
					break;
				}
			} else {
				switch (ptsev->ev.whom.key.ascii) {
				case '\r':	/* ^[L[ENTERL[ */
					if (pese->tmode == 0)
						moveEdit(pese, 1);
					else {
						moveEdit(pese, 1);
						num = 1; /* [s]{^ */
					}
					break;
				case '\x1b':	/* ESCL[		*/
					num = 2; /* []{^	*/
					break;
				default:	/* ̑̃L[		*/
					TMEventW(pese->tEdit, ptsev);
					break;
				}
			}
		} else
			/* ̑̃L[̏ꍇ */
			TMEventW(pese->tEdit, ptsev);
		break;
	case E_MSLDOWN:			/* }EXtg_ECxg	*/
		/* _CAOO̍ẂA`FbNȂ */
		lpt = GMGlobalToLocal(ptsev->ev.where.x_y);
		if (GMPtInRect(&pese->rcFrame, lpt)) {
			partCode = CMFind(lpt, pese->windowPtr, &ctrlHdl);
			/* [s]{^ꂽH */
			if (ctrlHdl == pese->execBtnHdl) {
				if (CMCheck(ctrlHdl, lpt, NULL) == C_INBTTN) {
					/* ݂̕ҏWҔ */
					len = TMGetText(pese->tEdit, pese->tBuff[pese->tmode], 3);
					pese->tBuff[pese->tmode][len] = 0;
					num = 1; /* [s]{^	*/
				}
			/* []{^ꂽH */
			} else if (ctrlHdl == pese->canBtnHdl) {
				if (CMCheck(ctrlHdl, lpt, NULL) == C_INBTTN)
					num = 2; /* []{^	*/
			} else if (GMPtInRect(&pese->rcDest, lpt))
				/* ҏẄɃ|C^ */
				TMEventW(pese->tEdit, ptsev);
			else if (GMPtInRect(&pese->rcText[0], lpt))
				moveEdit(pese, 0);
			else if (GMPtInRect(&pese->rcText[1], lpt))
				moveEdit(pese, 1);
		}
		break;
	case E_MSRDOWN:			/* }EXCg_ECxg	*/
		TMEventW(pese->tEdit, ptsev);
		break;
	}
	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);
	setClip(pese->windowPtr, &pese->rcFrame);

	return num;
}

/******************************************************************************
 *	getEseVal():	t̎擾
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		int *data	li[|C^
 *		int mode	擾鍀
 *				=  0: 
 *				=  1: 
 *	߂l:	int		<  0: 擾s
 *				>= 0: 擾
 */
int getEseVal(EseDlg *pese, int *data, int mode)
{
	int len, fields;
	char str[16];

	len = TMGetText(pese->tEdit, str, 3);
	str[len] = 0;
	/* lɕϊ */
	fields = sscanf(str, "%d", &pese->value[pese->tmode]);
	if (fields < 1)
		pese->value[pese->tmode] = 0;
	*data = pese->value[mode];

	return len;
}

/******************************************************************************
 *	setEseVal():	t̐ݒ
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		int data	t̒lւ̃|C^
 *		int mode	ݒ荀
 *				=  0: 
 *				=  1: 
 *	߂l:	int errCode	<  0: ݒ莸s
 *				>= 0: ݒ萬
 */
int setEseVal(EseDlg *pese, int data, int mode)
{
	int len, errCode = 0;
	char str[16];

	pese->value[mode] = data;	/* l[NɃRs[	*/
	if (pese->tmode == mode) {
		/* w̕ҏẄ悪ҏWł */
		len = sprintf(str, "%3d", data);
		errCode = TMSetText(pese->tEdit, str, len);
	}
	if (pese->visible)
		/* \Ă΃Abvf[g */
		addUpdate(pese->windowPtr, &pese->rcDest);

	return errCode;
}

/******************************************************************************
 *	moveEdit():	͍ڂ̕ύX
 ******************************************************************************
 *	:	EseDlg *pese	^_CAOR[hւ̃|C^
 *		int mode	͍
 *				= 0: 
 *				= 1: 
 *	:	J[\ړē͍ڂ̕ύXs܂B
 */
void moveEdit(EseDlg *pese, int mode)
{
	int len, fields;
	char str[16];

	if (pese->tmode == mode)
		/* ҏWeLXgȑOƓȂ */
		return;

	TMHide(pese->tEdit);
	/* eLXgpfBXeBl[VN^O쐬 */
	pese->rcDest = pese->rcText[mode];
	pese->rcDest.d.left += 3;
	pese->rcDest.d.top += 3;
	pese->rcDest.d.right -= 3;
	pese->rcDest.d.bottom -= 3;
	/* eLXgҏW̃N^OĐݒ肷 */
	TMSetRect(pese->tEdit, &pese->rcDest, &pese->rcDest);
	len = TMGetText(pese->tEdit, str, 3); /* ҏWҔ	*/
	str[len] = 0;
	fields = sscanf(str, "%d", &pese->value[pese->tmode]);
	if (fields < 1)
		pese->value[pese->tmode] = 0;
	/* ړ̃eLXgɕݒ肷 */
	len = sprintf(str, "%3d", pese->value[mode]);
	TMSetText(pese->tEdit, str, len);
	pese->tmode = mode;
	TMShow(pese->tEdit);
	TMSetSelect(pese->tEdit, 0, (*pese->tEdit)->length, 0);
	if (pese->visible) {
		/* \Ă΃Abvf[g */
		addUpdate(pese->windowPtr, &pese->rcText[0]);
		addUpdate(pese->windowPtr, &pese->rcText[1]);
	}
}

/******************************************************************************
 *	setClip():	NbsO̐ݒ
 ******************************************************************************
 *	:	Window *winPtr	EBhE|C^
 *		Rect *prect	N^Oւ̃|C^
 */
void setClip(Window *winPtr, Rect *prc)
{
	Region **rgnHdl;

	rgnHdl = GMNewRgn();
	if (rgnHdl == NULL) {
		DMError(D_CONFIRM, "mۂł܂B");
		return;
	}
	GMRectRgn(rgnHdl, &winPtr->graph.rect);
	GMDiffRectRgn(rgnHdl, rgnHdl, prc);
	GMSetClip(rgnHdl);
	GMDisposeRgn(rgnHdl);		/* [Wnh	*/
}

/******************************************************************************
 *	releaseClip():	NbsỎ
 ******************************************************************************
 *	:	Window *winPtr	EBhE|C^
 */
void releaseClip(Window *winPtr)
{
	GMClipRect(&winPtr->graph.rect);
}
